/*
  A program which opens a window and draws the "color cube."

  Use the arrow keys and +/-, PgUp,PgDn, Home,End, Ins,Del 
  keys to make the cube move.

  Use w/W to toggle between wireframe and solid models
  Use c/C to toggle backface culling on/off

  Written by - 
               Parag Chaudhuri
	       Research Scholar,
	       DCSE, IITD.
*/
#ifndef COLORCUBE_H
#define COLORCUBE_H

// Defining the ESCAPE Key Code
#define ESCAPE 27
// Defining the DELETE Key Code
#define DELETE 127

// Translation Parameters
GLfloat xpos=0.0,ypos=0.0,zpos=0.0;
// Rotation Parameters
GLfloat xrot=0.0,yrot=0.0,zrot=0.0;

//Running variable to toggle culling on/off
bool enable_culling=true;
//Running variable to toggle wireframe/solid modelling
bool solid=true;

//Cube vertices
static GLfloat vertices[] = 
{
  -1.0,-1.0,-1.0,
  1.0,-1.0,-1.0,
  1.0,1.0,-1.0,
  -1.0,1.0,-1.0,
  -1.0,-1.0,1.0,
  1.0,-1.0,1.0,
  1.0,1.0,1.0,
  -1.0,1.0,1.0
};

//Vertex colors
static GLfloat colors[] =
{
  0.0,0.0,0.0,
  0.0,1.0,0.0,
  0.0,1.0,1.0,
  0.0,0.0,1.0,
  1.0,0.0,0.0,
  1.0,1.0,0.0,
  1.0,1.0,1.0,
  1.0,0.0,1.0
};

//The vertex index ordering which make up the cube
static GLubyte allIndices[] = {4, 5, 6, 7, 1, 2, 6, 5, 0, 1, 5, 4, 0, 3, 2, 1, 0, 4, 7, 3, 2, 3, 7, 6};

//-------------------------------------------------------------------------

GLvoid InitGL(GLvoid);
GLvoid ReshapeGL (GLsizei Width, GLsizei Height);
GLvoid DisplayGL(GLvoid);
GLvoid KeyPressedGL(unsigned char key, GLint x, GLint y);
GLvoid SpecialKeyPressedGL(GLint key, GLint x, GLint y);
GLvoid RenderGL(int argc, char** argv);

//-------------------------------------------------------------------------

#endif
